#include "VariablesConfiguration.h"
#include <QTabWidget>
#include <QVBoxLayout>


VariablesConfigurationPanel::VariablesConfigurationPanel(QWidget* p /*= nullptr*/)
	:QWidget(p),
	_input_vars_model(new QStandardItemModel(this)),
	_output_vars_model(new QStandardItemModel(this)),
	_input_table(new QTableView(this)),
	_output_table(new QTableView(this))
{
	auto vbox = new QVBoxLayout(this);

	auto tabw = new QTabWidget(this);
	vbox->addWidget(tabw);

	tabw->addTab(_input_table, u8"");
	tabw->addTab(_output_table, u8"");
	tabw->setTabPosition(QTabWidget::West);

	vbox->setMargin(0);
	_input_table->setModel(_input_vars_model);
	_output_table->setModel(_output_vars_model);
	_input_vars_model->setHorizontalHeaderLabels(QStringList()
		<< u8"" << u8"" << u8"ת" << u8"");
	_output_vars_model->setHorizontalHeaderLabels(QStringList()
		<< u8"" << u8"" << u8"ת" << u8"Ŀ");
}

#include <QDebug>
void VariablesConfigurationPanel::bindNode(std::shared_ptr<LogicalNode> inst)
{
	this->_active_node = inst;

	qDebug() << __FILE__ << __LINE__ << inst->rtName();
}
